/*************************************************************************************************** 
Title:		SPI - C-interface - ADSP-2191 Evaluation Board

Date  : 	06/01

Information- Connection of an AC7476 to the ADSP-2191 via SPI.

****************************************************************************************************/
#include<signal.h>
#include<sysreg.h>

//----------------------------------------------------------------------------------------------
//				GLOBAL & EXTERNAL DECLARATIONS														
//---------------------------------------------------------------------------------------------- 
void SPI0_Interrupt_Priority(void);
void Initialization_of_SPI0(void);
void SPI_recieve();

//----------------------------------------------------------------------------------------------
//			   DM DATA																
//----------------------------------------------------------------------------------------------
int received_data[80];
int i;

//----------------------------------------------------------------------------------------------  
//				Program memory code 															
//----------------------------------------------------------------------------------------------  
void main(void)
{ 
  	SPI0_Interrupt_Priority();										
	Initialization_of_SPI0();
  
	sysreg_write(sysreg_IOPG , 0x4);		/* Select IO page */
	received_data[i] = io_space_read(0x4);	/* Dummy read from SPI0 */
	
	interrupt(SIG_INT5,SPI_recieve);		/* SPI0 interrupt masks and calls interrupt routine */
	
	for (;;)
	{
	 	asm("idle;");
	}
    
}

/**************************************************************************/

void SPI0_Interrupt_Priority(void)
{
	sysreg_write(sysreg_IOPG , 0x1);		/* Select IO page */

	io_space_write(0x200, 0xffff);			/* Set Interrupt Priorities */
	io_space_write(0x201, 0xff1f);			/* SPI0 set to priority 1 */
	io_space_write(0x202, 0xffff);
	io_space_write(0x203, 0xffff);
}

/**************************************************************************/

void Initialization_of_SPI0(void)
{
	sysreg_write(sysreg_IOPG , 0x0);		/* Select IO page */
	
	io_space_write(0x204, 0x11);			/* Map Interrupt Vector Table to Page 0*/
											/* Turn on SPI */

	sysreg_write(sysreg_IOPG , 0x4);		/* Select IO page */

	io_space_write(0x1, 0xff02);			/* Enable Slave On PF2 */
	io_space_write(0x5, 0x50);				/* Set SPI0 Baud rate, => SCLK0 ~= 50Khz*/
	io_space_write(0x0, 0x5908);			/* Set SPI0 Configuration Reigster */
											/* Enable SPI0 as MASTER */
}

/**************************************************************************/

void SPI_recieve()
{
static int count=0;
	
	sysreg_write(sysreg_IOPG , 0x4);		/* Select IO page */
	
	count++;								/* Interrupt counter */

	received_data[i] = io_space_read(0x4);	/* Read from SPI0 Receive Buffer Register */	
	i++;

	if (i >= 80) 
		i=0;
}

